package cli

import (
	"flag"
	"fmt"

	"git.rdelaage.ovh/rdelaage/VolumesAndDatabasesBackup/version"
	"git.rdelaage.ovh/rdelaage/VolumesAndDatabasesBackup/volumes"
)

const (
	flagInfoHelp       = "Show application information"
	flagVersionHelp    = "Show application version"
	flagConfigFileHelp = "Load configuration file"
)

func Parse() {
	var (
		flagInfo       bool
		flagVersion    bool
		flagConfigFile string
	)

	flag.BoolVar(&flagInfo, "info", false, flagInfoHelp)
	flag.BoolVar(&flagInfo, "i", false, flagInfoHelp)
	flag.BoolVar(&flagVersion, "version", false, flagVersionHelp)
	flag.BoolVar(&flagVersion, "v", false, flagVersionHelp)
	flag.StringVar(&flagConfigFile, "config-file", "", flagConfigFileHelp)
	flag.StringVar(&flagConfigFile, "c", "", flagConfigFileHelp)
	flag.Parse()

	if flagInfo {
		info()
		return
	}

	if flagVersion {
		fmt.Println(version.Version)
		return
	}

	volumeList, err := volumes.ListVolumesToBeBackedUp()
	if err != nil {
		fmt.Println("Failed to get a list of volumes to backup", err)
		return
	}

	fmt.Println(volumeList)
}
